#!/usr/bin/perl -w
#
# Copyright (C) 2001,2002 asdfGroup.com Inc. All rights reserved.
#
# This library is a commercial product and it is subject to the license
# agreement that can be found at the following URL:
#   http://www.asdfGroup.com/license.html
# Please contact our staff if you will have any questions:
#   mailto:staff@asdfGroup.com
#

use strict;

sub MEM_used{ ((Cat("/proc/self/status") or die $!) =~ /VmRSS:\s*(\d*)/)[0] };

sub FD_used {
    local *FD; opendir FD, "/proc/self/fd";
    return @{[readdir FD]} - 2;
};

sub CPU_used { (map {$_->[13]+$_->[14]} [split " ", Cat("/proc/self/stat")])[0] }

sub Limit_CPU { # max_cpu_percent
    eval "use Time::HiRes qw(setitimer ITIMER_PROF);";
    return warn("Can't limit CPU usage: $@\n") if $@;
    return warn("Can't limit CPU usage: bad param") if $_[0] <= 0 or $_[0] > 100;
    POWER::lib::_CronInit() if !defined($POWER::lib::TIME);
    my $cpumax = 100 / $_[0];
    my ($interval, $start, $prof) = (&MIN_INT, $POWER::lib::TIME, 0);
    $SIG{PROF} = sub { $prof += $interval };
    setitimer(&ITIMER_PROF, $interval, $interval);
    CronSet("PROF", $interval, sub {
	my $overtime = $prof*$cpumax - ($POWER::lib::TIME-$start);
	ConkOut($overtime) if $overtime >= &MIN_INT;
	});
}

1;
