#!/usr/bin/perl -w
use Test; 
BEGIN { plan tests => 6 }
BEGIN { unshift @INC, "../blib/lib" }
use POWER::lib qw(CPU_used time);

$used   = CPU_used() / 100;
$t0 = time(); 1 while time()-$t0 < 0.2;
$used2  = CPU_used() / 100;
ok(($used2-$used)>=0.1, 1,  "used, no lesser than 0.1 sec");
ok(($used2-$used)<=0.3, 1,  "used, no greater than 0.3 sec");

$used = CPU_used();
$timeout = 0; $SIG{ALRM} = sub { $timeout++ }; alarm(2); 1 until $timeout;
$used = CPU_used() - $used;
ok(($used<=220) && ($used>=180), 1,  "CPU_used: CPU unlimited, 2 sec");

Limit_CPU(50);
$used = CPU_used();
$timeout = 0; $SIG{ALRM} = sub { $timeout++ }; alarm(2); 1 until $timeout;
$used = CPU_used() - $used;
ok(($used<=110) && ($used>=90), 1,  "CPU_used: CPU 50%, 2 sec");

Limit_CPU(10);
$used = CPU_used();
$timeout = 0; $SIG{ALRM} = sub { $timeout++ }; alarm(2); 1 until $timeout;
$used = CPU_used() - $used;
ok(($used<=22) && ($used>=18), 1,  "CPU_used: CPU 10%, 2 sec");

Limit_CPU(100);
$used = CPU_used();
$timeout = 0; $SIG{ALRM} = sub { $timeout++ }; alarm(2); 1 until $timeout;
$used = CPU_used() - $used;
ok(($used<=220) && ($used>=180), 1,  "CPU_used: CPU 100%, 2 sec");

